//Do not edit this list variable yourself, use the AddToDeAsciifyList, clearDeAsciifyList and resetDeAsciifyList commands ingame instead.
$deAsciify::List="NONE& -& ae& AE& CE& oe& ...& 0 1 2 3 4 5 6 7 8 9 a& A& b B& c& C& d D& e& E& f& F g G h H i& I&| j J k K l&| L m M n& N& o& O& p P q Q r R& s& S& t& T u& U& v V w W x& X y& Y& z& Z& ! ?&";
$deAsciify::FilePath="config/server/deAsciify.txt";

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Effect on Chat","deAsciify","$Pref::Server::deAsciify::ChatMode","list None 0 Minimal 1 Full 2","Script_deAsciify",2,0,1);
	RTB_registerPref("Announce Name Changes?","deAsciify","$Pref::Server::deAsciify::AnnounceNameChange","bool","Script_deAsciify",true,0,1);
}
else
{
	$Pref::Server::deAsciify::ChatMode=2;
	// 0 - Names are changed for deAsciify when looking up player names, so "/find " will successfully find tardo.
	// 1 - The same as number 0, but deAsciified versions of names are shown in chat next to a player's normal name.
	// 2 - The same as number 0, but chat is replaced with an entirely deAsciified version. The only indication that a player's name has been deAsciified will be that it still has ascii characters in the player list. 
	$Pref::Server::deAsciify::AnnounceNameChange=true;
}

if(!isFunction("parseLinks"))
	exec("Add-Ons/Script_deAsciify/support_parseLinks.cs");

package deAsciify
{
	function GameConnection::autoAdminCheck(%this)
	{
		Parent::autoAdminCheck(%this);
		%name=doClientNameCheck(%this.bl_id,deAsciify(%this.name),2);
		%this.useThisName=%name;
		if($Pref::Server::deAsciify::AnnounceNameChange && %this.useThisName!$=%this.name)
			schedule(100,0,"messageAll",'',"\c4DeAsciify: \c1Name has been changed to\c3" SPC %name @ "\c1.");
	}
	function findClientByName(%in)
	{
		for(%x=0;%x<ClientGroup.getCount();%x++)
		{
			%client=ClientGroup.getObject(%x);
			%test=getStringMatchRatio(%client.useThisName,%in);
			if(%test>%best)
			{
				%best=%test;
				%out=%client;
			}
		}
		return(%out$="" ? Parent::findClientByName(%in) : %out);
	}
	function serverCmdMessageSent(%client,%msg)
	{
		if($Pref::Server::deAsciify::ChatMode==0)
			return(Parent::serverCmdMessageSent(%client,%msg));
		else if($Pref::Server::deAsciify::ChatMode==1 && (%client.useThisName=deAsciify(%client.name))!$=%client.name)
			messageAll('',"\c7" @ %client.clanPrefix @ "\c3" @ %client.name @ "\c7" @ %client.clanSuffix @ " \c8(<color:ffed87>" @ %client.useThisName @ "\c8)" @ "\c6:" SPC parseLinks(deAsciify(stripMLControlChars(%msg))));
		else if($Pref::Server::deAsciify::ChatMode==1)
			Parent::serverCmdMessageSent(%client,deAsciify(%msg));
		else if($Pref::Server::deAsciify::ChatMode==2)
			messageAll('',"\c7" @ %client.clanPrefix @ "\c3" @ %client.useThisName @ "\c7" @ %client.clanSuffix @ "\c6:" SPC parseLinks(deAsciify(stripMLControlChars(%msg))));
	}
};
activatePackage(deAsciify);

function getStringMatchRatio(%in,%test)
{ //returns ratio of matching letters to number of letters
	for(%x=0;%x<strLen(%in);%x++)
	{
		%m+=(getSubStr(%in,%x,1)$=getSubStr(%test,%x,1));
	}
	return(%m/strLen(%in));
}

function doClientNameCheck(%BLID,%in,%time)
{
	for(%x=0;%x<ClientGroup.getCount();%x++)
	{
		%next=ClientGroup.getObject(%x);
		if(%next.useThisName$=%in && %next.bl_id!=%BLID)
			return(doClientNameCheck(%BLID,%in @ %time,%time+1));
	}
	return(%in);
}

function deAsciify(%in)
{
	for(%x=0;%x<strLen(%in);%x++)
	{
		%next=getSubStr(%in,%x,1);
		%list=openDeAsciifyList(!isFile($deAsciify::FilePath));
		%use=checkDeAsciifyList(%list,%next);
		%next=(%use$="OK" ? %next : (%use$="NONE" ? "" : %use));
		%out=(%out$="" ? %next : %out @ %next);
	}
	if(isObject($deAsciify::File))
		$deAsciify::File.delete();
	return(%out);
}

function openDeAsciifyList(%firstTime)
{
	if(!isObject($deAsciify::File))
		$deAsciify::File=new fileObject();
	if(%firstTime)
	{
		$deAsciify::File.openForWrite($deAsciify::FilePath);
		%x=0;
		while((%next=getWord($deAsciify::List,%x))!$="")
		{
			$deAsciify::File.writeLine(strReplace(%next,"&"," "));
			%x++;
		}
		$deAsciify::File.close();
	}
	$deAsciify::File.openForRead($deAsciify::FilePath);
	return($deAsciify::File);
}

function checkDeAsciifyList(%file,%char)
{
	%check=false;
	while(!%file.isEOF() && !%check)
	{
		%line=%file.readLine();
		%next=getWord(%line,1);
		for(%x=0;%x<strLen(%next);%x++)
		{
			%check=(%char$=getSubStr(%next,%x,1));
			if(%check)
				break;
		}
	}
	%file.close();
	return(%check ? firstWord(%line) : "OK");
}

function serverCmdAddToDeAsciifyList(%client,%symbol,%replacement)
{
	if(%symbol$="" || %symbol$=" " || !isFile($deAsciify::FilePath) || !%client.isSuperAdmin)
		return;
	%in=(%replacement$="" || %replacement$=" " ? "NONE" : %replacement);
	%file=new fileObject();
	%fileB=new fileObject();
	%file.openForRead($deAsciify::FilePath);
	%fileB.openForWrite($deAsciify::FilePath);
	while(!%file.isEOF())
	{
		%line=%file.readLine();
		if(firstWord(%line)$=%in && (strCmp(firstWord(%line),%in)==0) && !%done)
		{
			%done=true;
			%fileB.writeLine(%line @ %symbol);
		}
		else
			%fileB.writeLine(%line);
	}
	if(!%done)
		%fileB.writeLine(%in SPC %symbol);
	%file.close(); %fileB.close(); %file.delete(); %fileB.delete();
	%client.chatMessage("\c2deAsciify settings changed: \c3'" @ %symbol @ "' \c6will now be " @ (%in$="NONE" ? "removed from" : "replaced with \c3'" @ %in @ "'\c6 in") @ " player names and chat.");
}

function serverCmdResetDeAsciifyList(%client)
{
	if(!%client.isSuperAdmin)
		return;
	%list=openDeAsciifyList(true);
	%list.close(); %list.delete();
	%client.chatMessage("\c2deAsciify list reset.");
}

function serverCmdClearDeAsciifyList(%client)
{
	if(!%client.isSuperAdmin)
		return;
	%list=new fileObject();
	%list.openForWrite($deAsciify::FilePath);
	%list.close(); %list.delete();
	%client.chatMessage("\c2deAsciify list cleared.");
}
//shorter commands:
function serverCmdAddToDAL(%client,%symbol,%replacement)
{
	serverCmdAddToDeAsciifyList(%client,%symbol,%replacement);
}

function serverCmdResetDAL(%client)
{
	serverCmdResetDeAsciifyList(%client);
}

function serverCmdClearDAL(%client)
{
	serverCmdClearDeAsciifyList(%client);
}